import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:oin_pos_plugin/oin_pos_plugin.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';

  @override
  void initState() {
    super.initState();
  }

  connectBlueTooth() {
    OinPosPlugin.connectBluetooth();
  }

  searchPort() {
    OinPosPlugin.searchPort();
  }

  openCashDrawer() {
    OinPosPlugin.openCashDrawer();
  }

  testPrint() {
    OinPosPlugin.printTestReceipt();
  }

  getPortname() async {
    String portName;
    // OinPosPlugin.openCashDrawer();
    try {
      portName = await OinPosPlugin.portName;
    } on PlatformException {
      portName = 'Failed to get platform version.';
    }
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Column(
            children: <Widget>[
              RaisedButton(
                onPressed: connectBlueTooth,
                child: Text("藍芽連線"),
                color: Colors.red,
                textColor: Colors.white,
                splashColor: Colors.black,
              ),
              RaisedButton(
                onPressed: getPortname,
                child: Text("CurrentPort"),
                color: Colors.red,
                textColor: Colors.white,
                splashColor: Colors.black,
              ),
              RaisedButton(
                onPressed: searchPort,
                child: Text("SearchPort"),
                color: Colors.red,
                textColor: Colors.white,
                splashColor: Colors.black,
              ),
              RaisedButton(
                onPressed: openCashDrawer,
                child: Text("打開錢櫃"),
                color: Colors.red,
                textColor: Colors.white,
                splashColor: Colors.black,
              ),
              RaisedButton(
                onPressed: testPrint,
                child: Text("列印測試"),
                color: Colors.red,
                textColor: Colors.white,
                splashColor: Colors.black,
              ),
            ],
          ),
        ),
      ),
    );
  }
}
