//
//  ApiFunctions.swift
//  oin_pos_plugin
//
//  Created by 逸唐陳 on 2020/7/27.
//

import Foundation

class ApiFunctions {
  static func createPeripheralData(_ emulation: StarIoExtEmulation) -> Data {
    let builder: ISCBBuilder = StarIoExt.createCommandBuilder(emulation)
    
    builder.beginDocument()
    
    builder.appendPeripheral(SCBPeripheralChannel.no1)
    builder.appendPeripheral(SCBPeripheralChannel.no2)
    builder.appendPeripheral(SCBPeripheralChannel.no1, time: 2000)
    builder.appendPeripheral(SCBPeripheralChannel.no2, time: 2000)
    
    builder.endDocument()
    
    return builder.commands.copy() as! Data
  }
  
  static func append3inchTextReceiptData(_ emulation: StarIoExtEmulation) -> Data {
    let space: Data = "   ".data(using: .ascii)!
    let space2: Data = " ".data(using: .ascii)!
    let otherDataNw7: Data = "A0123456789B".data(using: String.Encoding.ascii)!
    let rect = CGRect(x: 0, y: 0, width: 576,  height: 240)
    let builder: ISCBBuilder = StarIoExt.createCommandBuilder(emulation)
    let encoding = String.Encoding(rawValue: CFStringConvertEncodingToNSStringEncoding(CFStringEncoding(CFStringEncodings.big5.rawValue)))
    builder.beginDocument()
    builder.appendCharacterSpace(0)
    builder.appendAlignment(SCBAlignmentPosition.center)
    builder.appendEmphasis(true)
    builder.appendCharacterSpace(5)
    builder.appendData(withMultipleHeight: "碳佐麻里精品燒肉\n".data(using: encoding), height: 2)
    builder.appendCharacterSpace(0)
    builder.appendEmphasis(false)
    builder.append("---------------------------------\n".data(using: encoding))
    builder.appendData(withMultiple: (
      "電子發票證明聯\n" +
        "103年01-02月\n" +
      "EV-99999999\n").data(using: encoding), width: 2, height: 2)
    builder.appendAlignment(SCBAlignmentPosition.left)
    builder.append((
      "2014/01/15 13:00\n" +
        "隨機碼 : 9999       總計 : 999\n" +
        "賣方 : 99999999\n").data(using: encoding))
    builder.appendBarcodeData(withAlignment: otherDataNw7, symbology: .NW7, width: .extMode1, height: 40, hri: false, position: .center)
    builder.beginPageMode(rect, rotation: SCBBitmapConverterRotation.normal)
    builder.append(space)
    builder.appendQrCodeData("http://www.star-m.jp/eng/index.html".data(using: String.Encoding.ascii), model: .no2, level: .Q, cell: 4)
    builder.append(space)
    builder.append(space)
    builder.append(space2)
    builder.appendQrCodeData("http://www.star-m.jp/eng/index.html".data(using: String.Encoding.ascii), model: .no2, level: .Q, cell: 4)
    builder.endPageMode()
    
    //        builder.appendAlignment(SCBAlignmentPosition.left)
    //
    //        builder.append((
    //            "\n" +
    //            "商品退換請持本聯及銷貨明細表。\n" +
    //            "9999999-9999999 999999-999999 9999\n" +
    //            "\n").data(using: encoding))
    //
    //        builder.appendData(withAlignment: "銷貨明細表 　(銷售)\n".data(using: encoding), position: SCBAlignmentPosition.center)
    //
    //        builder.appendData(withAlignment: "2014-01-15 13:00:02\n".data(using: encoding), position: SCBAlignmentPosition.right)
    //
    //        builder.append((
    //            "\n" +
    //            "烏龍袋茶2g20入                55 x2 110TX\n" +
    //            "茉莉烏龍茶2g20入              55 x2 110TX\n" +
    //            "天仁觀音茶2g*20               55 x2 110TX\n").data(using: encoding))
    //
    //        builder.appendData(withEmphasis: (
    //            "      小　 計 :                330\n" +
    //            "      總   計 :                330\n").data(using: encoding))
    //
    //        builder.append((
    //            "------------------------------------------------\n" +
    //            "現 金                          400\n" +
    //            "      找　 零 :                 70\n").data(using: encoding))
    //
    //        builder.appendData(withEmphasis: " 101 發票金額 :                330\n".data(using: encoding))
    //
    //        builder.append((
    //            "2014-01-15 13:00\n" +
    //            "\n").data(using: encoding))
    //
    //        builder.appendAlignment(SCBAlignmentPosition.center)
    //
    ////      builder.appendBarcodeData("{BStar.".data(using: encoding),              symbology: SCBBarcodeSymbology.Code128, width: SCBBarcodeWidth.Mode2, height: 40, hri: true)
    //        builder.appendBarcodeData("{BStar.".data(using: String.Encoding.ascii), symbology: SCBBarcodeSymbology.code128, width: SCBBarcodeWidth.mode2, height: 40, hri: true)
    //
    //        builder.appendAlignment(SCBAlignmentPosition.left)
    //
    //        builder.append((
    //            "\n" +
    //            "商品退換、贈品及停車兌換請持本聯。\n" +
    //            "9999999-9999999 999999-999999 9999\n").data(using: encoding))
    builder.appendCutPaper(SCBCutPaperAction.partialCutWithFeed)
    builder.endDocument()
    
    return builder.commands.copy() as! Data
  }
}
