import 'dart:async';

import 'package:flutter/services.dart';

class OinPosPlugin {
  static const MethodChannel _channel =
      const MethodChannel('oin_pos_plugin');

  static Future<String> get platformVersion async {
    var receipts = <String, dynamic>{"storeName": "碳佐麻里燒肉",
                                     "invoiceNumber": "123456789",
                                     "orders": ["套餐A\t*2\t1,360元",
                                                "蒜蝦飯\t*1\t120元",
                                                "啤酒\t*1\t80元"]};
    final String version = await _channel.invokeMethod('testAlert', receipts);
    return version;
  }

  static printTestReceipt() {
    _channel.invokeMethod("testPrint");
  }

  static connectBluetooth() {
    _channel.invokeMethod("connectBluetooth");
  }

  static openCashDrawer() {
    _channel.invokeMethod("openCashDrawer");
  }

  static searchPort() {
    _channel.invokeMethod('searchPort');
  }

  static Future<String> get portName async {
    return await _channel.invokeMethod('currentPort');
  }
}
